#ifndef Hand_h
#define Hand_h
#pragma once

#include "Card.h"
#include <vector>
#include "Deck.h"
#include "HandClass.h"

using namespace std ;
class Hand
{

public:
	Hand(void): handClasses(20){} //a vector of hand classes where the weakest hand is last in the vector and straight flush is first.  To know the highest hand type you start at the beginning and walk the array until you find an element that is not empty
	~Hand(void);
    //void setTheCards(Hand aHand);
	vector<Card>& getTheCards();
	void addACard(Card theCard);
	void swapCard(Deck& theDeck, int handSpotToSwap);
	//prints the hand to the command line
	void printToCL();
	void clear();
	vector<HandClass>& getHandClasses();
	void establishHandClasses();
	void findNofAKind();
	Card findHighCard();
	bool isItAFlush();
	bool isItAStraight();
	bool istItAStraightFlush();
	void initializeHandClasses();
private:
	vector<Card> theCards;
	vector<HandClass> handClasses;
};



#endif
