#include "StdAfx.h"
#include "Player.h"
#include <iostream>
#include "HandClass.h"




Player::Player(void)
{
	Player::numPennies = 30;
	hasRunOutOfPennies = false;
}



Player::~Player(void)
{
}

Hand& Player::getHand() 
{
	return playersHand;
}


//deals a card into a player's hand
void Player::dealCardToPlayer(Card aCard)
{
	playersHand.addACard(aCard);
}


//gets the number of pennies a player has
int Player::getNumPennies()
{
	return numPennies;
}

//adds a winnings to a players pennies
void Player::addWinnings(int somePennies)
{
	numPennies += somePennies;
}

//takes a bet amount from the pennies
void Player::takeBetFromPennies(int aBet)
{
	if(aBet > numPennies)
	{
		setRunOut();
		numPennies = 0;
	}
	else
	{
		numPennies = numPennies - aBet;
	}
}

//clears a players hand
void Player::clearHand()
{
	playersHand.clear();
}

//returns the highest hand
HandClass::handClassification_t Player::getHighestHand()
{
	return highestHand;
}

//returns the highest hand class
HandClass Player::getHighestHandClass()
{
	return highestHandClass;
}


//Finds all the hand classifications and then returns the highest hand.  The order of the hand is 0 best, and that is the straight flush
HandClass Player::findHighestHand()
{
	HandClass tempClass;
	playersHand.establishHandClasses();
	//find the first loaded element of hand classes
	for(int i = 0 ; i < 14; i++)
	{
		if(playersHand.getHandClasses().at(i).isItLoaded())
		{
			tempClass = playersHand.getHandClasses().at(i);
			break;
		}
	}
	highestHand = tempClass.getClassification();
	highestHandClass = tempClass;
	return tempClass;
}



//just so that we can set an NPCplayer's hand
void Player::setsAHandForTest()
{
	//this is for testing purposes
	getHand().getTheCards()[0].setRank(10);
	getHand().getTheCards()[1].setRank(14);
	getHand().getTheCards()[2].setRank(13);
	getHand().getTheCards()[3].setRank(11);
	getHand().getTheCards()[4].setRank(12);
	getHand().getTheCards()[0].setSuit(Card::HEART);
	getHand().getTheCards()[1].setSuit(Card::SPADE);
	getHand().getTheCards()[2].setSuit(Card::SPADE);
	getHand().getTheCards()[3].setSuit(Card::SPADE);
	getHand().getTheCards()[4].setSuit(Card::SPADE);
	//this is for testing purposes
}

//if a player has run out of pennies they are dropped from the game
void Player::setRunOut()
{
	hasRunOutOfPennies = true;
}

//if a player has run out of pennies they are dropped from the game
bool Player::getRunOut()
{
	return hasRunOutOfPennies;
}

//if a player has run out of pennies they are dropped from the game
void Player::setNotRunOut()
{
	hasRunOutOfPennies = true;
}