#ifndef Player_h
#define Player_h
#pragma once

#include "Card.h"
#include "Deck.h"
#include "Hand.h"
#include "HandClass.h"

class Player
{
private:
	Hand playersHand;
	int numPennies;
	HandClass::handClassification_t highestHand;
	HandClass highestHandClass;
	bool hasRunOutOfPennies;
public:
	Player(void);
	~Player(void);
	Hand& getHand();
	void dealCardToPlayer(Card aCard);
	int getNumPennies();
	void addWinnings(int somePennies);
	void takeBetFromPennies(int aBet);
	//int playerBets(int theBet, Pot thePot);
	void clearHand();  //clears the hand at the beginning of a round
	HandClass findHighestHand();
	HandClass::handClassification_t getHighestHand();
	HandClass getHighestHandClass();
	void setsAHandForTest();
	void setRunOut();
	void setNotRunOut();
	bool getRunOut();

};

#endif