#include "StdAfx.h"
#include "aPokerGame.h"
#include "Deck.h"
#include <stdio.h>
#include <iostream>
#include "userPlayer.h"
#include "npcPlayer.h"
#include "pokerRound.h"
#include "Dealer.h"
#include "Viewer.h"
#include "Listener.h"
#include "pokerViewerController.h"
#include "InputHandler.h"

using namespace std; 

//initializes a poker game
aPokerGame::aPokerGame(void)
{
	stopPlaying = 'n';			
}


aPokerGame::~aPokerGame(void)
{
}


//the main game loop
void aPokerGame::playGame()
{
	Viewer theViewer;
	Dealer theDealer;
	pokerRound aRound;
	userPlayer thePlayer;	
	npcPlayer anOpponent;
	for(int i = 1 ; i < aPokerGame::numPlayers +1 ; i ++)
	{
		anOpponent = npcPlayer();
		anOpponent.setPlayerNumber(i);
		aPokerGame::theOpponents.push_back(anOpponent);
	}
	while (stopPlaying == 'n')
	{
		thePlayer.clearHand();
		for(std::vector<npcPlayer>::iterator it= theOpponents.begin() ; it != theOpponents.end(); ++it)
		{
			(*it).clearHand();
		}
		//clear the deck if it is not already cleared and do it in the best memory way!!!
		theDeck = Deck();
		theDeck.vectorShuffle();
		//returns false if the player has lost
		if(!aRound.startRound(theOpponents,thePlayer, theDeck, theDealer, theViewerController))
		{
			stopPlaying = 'y';
		}
		else
		{
			aPokerGame::stopGame();
			if(stopPlaying == 'n')
			{
				cout << "\n Great!  Let's keep playing! \n";
			}
		}
	}
	bool finished;
	cout << "\n Thanks for playing!";
	cin >> finished;
}

void aPokerGame::setNumPlayers(int Players){
	numPlayers = Players;
}

void aPokerGame::stopGame()
{
	char inputVals[2] = {'y', 'n'};
	cout << "\n Stop Playing? (y/n)";
	stopPlaying = theViewerController.theInputHandler.getChar(inputVals, 2);
	while (stopPlaying != 'n' && stopPlaying != 'y')
	{		
		cout << "\n Please Choose y or n";
		cin >> stopPlaying;
	}
}	

