#include "StdAfx.h"
#include "pokerRound.h"
#include "npcPlayer.h"
#include <vector>
#include "userPlayer.h"
#include <iostream>
#include "Deck.h"
#include "Hand.h"
#include "Dealer.h"
#include "Player.h"
#include "pokerViewerController.h"
#include "Listener.h"
#include <time.h>
#include <algorithm>

using namespace std;

pokerRound::pokerRound(void)
{
}



pokerRound::~pokerRound(void)
{
}


Hand aHand;
//deals a hand to each player
void dealToPlayers(vector<npcPlayer> &theOpponents, userPlayer &theUser, Deck &theDeck, Dealer &theDealer)
{
	//create a hand
	theDealer.DealAHand(theDeck, theUser);
	//for each npc deal a hand
	for(std::vector<npcPlayer>::iterator it = theOpponents.begin(); it != theOpponents.end(); ++it)
	{
		theDealer.DealAHand(theDeck,*it);
	}


}

//shows all the hands
void showHands(Player theUser,vector<npcPlayer> theOpponents, pokerViewerController theViewerController){

		//show hands and pick the winner "should be a 
	cout << "\n Show your hands.\n";
	cout << "You: \n";
	theUser.getHand().printToCL();
	for(std::vector<npcPlayer>::iterator it= theOpponents.begin() ; it != theOpponents.end(); ++it)
	{
		//print the hand type that goes for each opponent
		cout << "\nPlayer " << (*it).getPlayerNumber() << " : \n";
		theViewerController.DrawHand((*it).getHand());
		//cout << "\n With a " << ((*it).findHighestHand()).getClassification()
	}	

}


//the opponent comparator
bool orderOpponents(npcPlayer p1, npcPlayer p2)
{
	return p1.getHighestHand() < p2.getHighestHand();
}


//finds the best opponent hand
npcPlayer& pokerRound::getWinningOpponent(vector<npcPlayer>& theOpponents )
{
	//iterate over all opponents and set their highest hand
	std::vector<npcPlayer>::iterator it;
	for(it = theOpponents.begin() ; it != theOpponents.end(); ++it)
	{
		//(*it).setNPCPlayerHandForTest();
		(*it).findHighestHand();
	}
	//sort the opponent vector based on their winning hands
	sort(theOpponents.begin(),theOpponents.end(), orderOpponents);
	return theOpponents.at(0);
}


//this is a poker round or hand.  It is a game which takes a user player, an npc and a Deck and simply plays a hand of poker.
//The round consistr of dealing 5 cards to each player, then allowing htem to bet (add pennies to the pot).  They get a chance to exhange up to three cards from the deck and the players bet again.  they exchange three more cards and then all hands are shown and the best hand wins
bool pokerRound::startRound(vector<npcPlayer> &theOpponents, userPlayer &theUser, Deck &theDeck, Dealer &theDealer, pokerViewerController theViewerController)
{
	int currentBet = 3;
	tableLimit = 100;
	int numDeals = 3;
	//int swapped;
	Deck discardDeck;
	int anNPCBet;
	Pot thePot = Pot();
	npcPlayer anNPC = npcPlayer();
	std::vector<npcPlayer>::iterator it;
	int userBet;
	theDeck.vectorShuffle();
	dealToPlayers(theOpponents,theUser,theDeck, theDealer);
	for(int i = 0 ; i < numDeals ; i++)
	{
		//show the player his hand
		cout << "\nHere is your hand: \n";
		theViewerController.DrawHand(theUser.getHand());		
		//get a bet from the player
		userBet = theUser.userBets(thePot, theViewerController, tableLimit);
		currentBet= userBet;
		srand((unsigned)time(NULL));
		for(it = theOpponents.begin() ; it != theOpponents.end(); ++it)
		{
			anNPCBet = (*it).npcBets(thePot, currentBet);
			cout << "\n Player " << (*it).getPlayerNumber() << " bets: " << anNPCBet << "\n";
		}
		//deal out three cards to user player
		theDealer.DealNCards(theDeck,theUser, theViewerController);
		//get a decision from players about swapping cards(for now, this is part of an AI that I will implement later)
		for(it = theOpponents.begin() ; it != theOpponents.end(); ++it)
		{
			//(*it).setNPCPlayerHandForTest();
		//	theDealer.dealThreeCardsToPlayer((*it), (*it).swapCards(), theDeck);
			//notice how you pass in (*it) to the next function.  You might not want to do that.  You might want to pass in the actual
			//need to test that dealthreecardstoplayer actually updates the player as we have passed in the values
			cout << "\n Player " << (*it).getPlayerNumber() << " discarded " << theDealer.dealThreeCardsToPlayer((*it), (*it).swapCards(), theDeck);
		}
	}



	////testing the comparisons
	//theUser.setsAHandForTest();
	//for(it = theOpponents.begin() ; it != theOpponents.end(); ++it)
	//{
	//	(*it).setNPCPlayerHandForTest();
	//}
	////testing


	showHands(theUser,theOpponents, theViewerController);
	//theUser.setsAHandForTest();
	HandClass::handClassification_t playersBestHand = (theUser.findHighestHand()).getClassification();
	bool playerWins = true;
	bool first = true;
	npcPlayer& theWinner = pokerRound::getWinningOpponent(theOpponents );
	if(theUser.getHighestHand() < theWinner.getHighestHand())
	{
		//player wins
		//collect wihhings
		theViewerController.NotifyPlayerWins(thePot.getPotValue(), theUser);
		thePot.playerCollectsWinnings(theUser);
		//notify the viewer of the winner

	}
	else if (theUser.getHighestHand() > theWinner.getHighestHand())
	{
		//player looses
		//give winnings to winner
		//notify the viewer of the winner
		theViewerController.NotifyOpponentWins(theWinner);
		thePot.playerCollectsWinnings(theWinner);
	}
	else
	{
		//have to do careful comparison between hands for different hand types
		//
	}

	if(theUser.getNumPennies() ==0)
	{
		theViewerController.NotifyUserOfMajorLoss();
		return false;
	}
	int oppIterStop = 0;
	int originalNumPlayers = theOpponents.size();
	for(int i = 0 ; i < originalNumPlayers; i++)
	{
		//theOpponents.erase(theOpponents.begin() + i);
		//check to see if the opponent has runn out of money, if so remove them from the list of opponents
		if((theOpponents.at(i - oppIterStop)).getNumPennies() == 0) 
		{
			//if there are no opponents left in the game, turn the game off, notify of win
			//otherwise, you need to remove a player
			theViewerController.NotifyOfOppnentLeavingGame((theOpponents.at(i - oppIterStop)));
			theOpponents.erase(theOpponents.begin() + (i - oppIterStop));
			oppIterStop++;
		}
		else if((theOpponents.at(i - oppIterStop)).getRunOut() && (theOpponents.at(i - oppIterStop)).getNumPennies() > 0)
		{
			(theOpponents.at(i - oppIterStop)).setNotRunOut();
		}

	}
	if(theOpponents.size() == 0)
	{
		theViewerController.NotifyUserOfMajorWin();
		return false;
	}
	return true;
}

