#include "StdAfx.h"
#include "pokerViewerController.h"
#include "Card.h"
#include "Hand.h"
#include "HandClass.h"
#include "Listener.h"
#include <iostream>
#include "Player.h"

pokerViewerController::pokerViewerController(void)
{
}


pokerViewerController::~pokerViewerController(void)
{
}



void pokerViewerController::DrawHand(Hand theHand)
{
	Card tempCard;
	for(std::vector<Card>::iterator it=(theHand.getTheCards()).begin(); it != (theHand.getTheCards()).end(); ++it)
	{
		//for each card in the hand, print the crd to the command line
		tempCard = *it;
		//tempCard.printToCL();
		printCardToCli(tempCard);
		cout << "  ";
	}
}


//takes the face enum and give back the string it corresponds to
std::string getFaceString(Card::faces_t aFace)
{
	switch(aFace){
	case Card::JACK:
		return "Jack";
	case Card::QUEEN:
		return "Queen";
	case Card::KING:
		return "King";
	case Card::ACE:
		return "Ace";
	}


}

//takes the suit enum and gives back the string it corresponds to
std::string getSuitString(Card::suits_t aSuit)
{
	switch(aSuit){
	case Card::HEART:
		return "Hearts";
	case Card::DIAMOND:
		return "Diamonds";
	case Card::CLUB:
		return "Clubs";
	case Card::SPADE:
		return "Spades";
	}

}


//prints a card to the cli
void pokerViewerController::printCardToCli(Card aCard)
{
	Card::faces_t theFace;
	if(aCard.getRank() < 11 )
	{
		cout << aCard.getRank() << " of ";
	}
	else
		switch(aCard.getRank()){
		case 11:
			theFace = Card::JACK;
			cout << getFaceString(theFace) << " of ";
			break;
		case 12:
			theFace = Card::QUEEN;
			cout << getFaceString(theFace) << " of ";
			break;
		case 13:
			theFace = Card::KING;
			cout << getFaceString(theFace) << " of ";
			break;
		case 14:
			theFace = Card::ACE;
			cout << getFaceString(theFace) << " of ";
			break;
		}
	;
	cout << getSuitString(aCard.getSuit());
}

//prints the text value for a given hand 
//STRAIGHT_FLUSH, FOUR_KIND, FULL_HOUSE, FLUSH, STRAIGHT,THREE_KIND, TWO_PAIR, PAIR, HIGH_CARD
string printHandClass(HandClass::handClassification_t aHandClass)
{
	switch (aHandClass)
	{
	case 0:
		return "a straight flush";
		break;
	case 1:
		return "four of a kind";
		break;
	case 2:
		return "a full house";
		break;
	case 3:
		return "a flush";
		break;
	case 4:
		return "a straight";
		break;
	case 5:
		return "three of a kind";
		break;
	case 6:
		return "two pair";
		break;
	case 7:
		return "a pair";
		break;
	case 8:
		return "high card";
		break;
	}
}



void pokerViewerController::listen()
{
}

//notifies the player that he has won
void pokerViewerController::NotifyPlayerWins(int numPennies, Player thePlayer)
{
	cout << "\n You win " << numPennies << " pennies with " << printHandClass(thePlayer.getHighestHand()) << "! \n";
}

//notifies the player that he has lost to an opponent
void pokerViewerController::NotifyOpponentWins(npcPlayer theWinningOpponent)
{
	cout << "\n You have lost to Player" << theWinningOpponent.getPlayerNumber() << ", who has " << printHandClass(theWinningOpponent.getHighestHand()) << "\n";
}

//notifies that a player has left the game
void pokerViewerController::NotifyOfOppnentLeavingGame(npcPlayer theLoser)
{
	cout << "\n Player " << theLoser.getPlayerNumber() << " has gone bankrupt and is leaving the game";
}


//void pokerViewerController::stopGame()
//{
//	char inputVals[2] = {'y', 'n'};
//	cout << "\n Stop Playing? (y/n)";
//	stopPlaying = theInputHandler.getChar(inputVals, 2);
//	while (stopPlaying != 'n' && stopPlaying != 'y')
//	{		
//		cout << "\n Please Choose y or n";
//		cin >> stopPlaying;
//	}
//}


//player has won
void pokerViewerController::NotifyUserOfMajorWin()
{
	cout <<"\n All players are bankrupt!  You win! \n";
}

//player has lost
void pokerViewerController::NotifyUserOfMajorLoss()
{
	cout << "\n You are bankrupt. Game Over. \n";
}